'
' -------------------------------------------------------------------
' Hash Table Demo             Check For Twin Function
' FreeBasic code compiled with FBtoRqInc    Jacques  August 1st, 2011         
' -------------------------------------------------------------------
'
' ==== RAPIDQ: CHECKFORTWINS.INC ===============================================
' FreeBasic source to compile with FbtoRqInc
' Type TTWIN
'     i As Integer
'     j As Integer
'     iMax As Integer
'     jMax As Integer
' End Type
'
' Function CheckForTwins (twin As TTWIN, ByVal table As Integer ptr, ii, jj) As Integer
'     Dim as Integer n, p
'     Function = 0
'     n = twin.i
'     p = twin.j
'     While n <= twin.iMax
'         While p <= twin.jMax
'             If table[n] = table[p] Then
'                 twin.i = n
'                 twin.j = p
'                 Function = 1
'                 Exit Function
'             End If
'             p += 1
'         Wend
'         n += 1
'         p = n + 1
'     Wend
' End Function
' ----------------
' Compilation result : directly executable in RapidQ
'
DECLARE FUNCTION Cwp_CHECKFORTWINS LIB "user32" ALIAS "CallWindowProcA" ( _
          ptrCHECKFORTWINS As Long, Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long _
          ) As Long
' ----- START ASM CHECKFORTWINS -----
DefByte ArrayCHECKFORTWINS (0 To 159) = _
   {&H55, &H89, &HE5, &H83, &HEC, &H0C, &H53, &HC7, &H45, &HFC, &H00, &H00,  _
    &H00, &H00, &HC7, &H45, &HF8, &H00, &H00, &H00, &H00, &HC7, &H45, &HF4,  _
    &H00, &H00, &H00, &H00, &HC7, &H45, &HFC, &H00, &H00, &H00, &H00, &H8B,  _
    &H45, &H08, &H8B, &H18, &H89, &H5D, &HF8, &H8B, &H5D, &H08, &H8B, &H43,  _
    &H04, &H89, &H45, &HF4, &H8B, &H45, &H08, &H8B, &H58, &H08, &H39, &H5D,  _
    &HF8, &H7F, &H52, &H8B, &H5D, &H08, &H8B, &H43, &H0C, &H39, &H45, &HF4,  _
    &H7F, &H3B, &H8B, &H45, &HF8, &HC1, &HE0, &H02, &H8B, &H5D, &H0C, &H01,  _
    &HC3, &H8B, &H45, &HF4, &HC1, &HE0, &H02, &H8B, &H4D, &H0C, &H01, &HC1,  _
    &H8B, &H01, &H39, &H03, &H75, &H1A, &H8B, &H45, &H08, &H8B, &H5D, &HF8,  _
    &H89, &H18, &H8B, &H5D, &H08, &H8B, &H45, &HF4, &H89, &H43, &H04, &HC7,  _
    &H45, &HFC, &H01, &H00, &H00, &H00, &HEB, &H11, &HFF, &H45, &HF4, &HEB,  _
    &HBA, &HFF, &H45, &HF8, &H8B, &H45, &HF8, &H40, &H89, &H45, &HF4, &HEB,  _
    &HA3, &H8B, &H45, &HFC, &H5B, &H89, &HEC, &H5D, &HC2, &H10, &H00, &H90,  _
    &H90, &H90, &H90, &H90}
' ----- END ASM CHECKFORTWINS -----
DefInt ptrCHECKFORTWINS = VarPtr (ArrayCHECKFORTWINS(0))
Function CHECKFORTWINS(Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long) As Long
    Result = Cwp_CHECKFORTWINS(ptrCHECKFORTWINS, Arg1, Arg2, Arg3, Arg4)
End Function
' CALL ME WITH: iRet = CHECKFORTWINS(Arg1, Arg2, Arg3, Arg4)
' ==== RAPIDQ: end of CHECKFORTWINS.INC ========================================
'
